!============================================================================
! subroutine cut_M
! changes the brittle and ductile values of M linearly through time at a given time step
! Olive 5/08
!============================================================================

subroutine cut_M
include 'precision.inc'
include 'params.inc'
include 'arrays.inc'

! seconds in a year
sec_year = 3.1558e+7
timeMYR=(1e-6)*time/sec_year
whencut2=whencut+Dtc
! Dtc = length of transition period (Myr)

if ((timeMYR .gt. whencut) .AND. (timeMYR .lt. whencut2)) then
rate_inject_brittle=((rate_inject_brittle2-rate_inject_brittle1)/Dtc)*(timeMYR-whencut)+rate_inject_brittle1
rate_inject_ductile=((rate_inject_ductile2-rate_inject_ductile1)/Dtc)*(timeMYR-whencut)+rate_inject_ductile1
else if (timeMYR .gt. whencut2) then
rate_inject_brittle=rate_inject_brittle2
rate_inject_ductile=rate_inject_ductile2
end if

end
