!============================================================================
! subroutine move_inject
! Locates the injection zone based on the highest point 
! of the 1200 degrees isotherm. 
! gives the values of iinj1 and iinj2.
! Olive 5/08
!============================================================================

subroutine move_inject
include 'precision.inc'
include 'params.inc'
include 'arrays.inc'

dimension bdt(1,nx)

! creating a vector with the depths of the 1200 degrees isotherm

do p=1,nx
pp=1
do while (temp(pp,p) .lt. 1200)
pp=pp+1
end do
bdt(1,p)=-cord(pp,p,2)+cord(1,p,2)
end do
! write(*,*) bdt

! locating the shallowest part of the isotherm
shal=bdt(1,1)
shalIndex=1
do k=2,nx
if (shal.gt.bdt(1,k)) then
shal=bdt(1,k)
shalIndex=k
end if
end do

!write(*,*) shalIndex

iinj1=shalIndex
iinj2=shalIndex+1

xinject=cord(1,iinj1,1)







end
